//
//  EDExportImportSchemeOwnerProtocol.h
//  EDExportImportScheme
//
//  Created by Arnaud Thiercelin on 10/26/11.
//  Copyright (c) 2011 Flying Pig. All rights reserved.
//

#import <Foundation/Foundation.h>

@class EDExportImportScheme;

@protocol EDExportImportSchemeOwnerProtocol <NSObject>

@required
@property (readonly) NSInteger currentUserLanguageId;

#pragma mark SQL Bridge
- (BOOL)scheme:(EDExportImportScheme *)scheme 
	wantsToExecRequest:(NSString *)request
	withRequestIdentifier:(NSString *)requestIdentifier
	withMetadata:(NSDictionary *)metadata
	andNotificationIdentifier:(NSString *)notifIdentifier;

@optional
- (BOOL)scheme:(EDExportImportScheme *)scheme 
wantsToExecRequest:(NSString *)request
withRequestIdentifier:(NSString *)requestIdentifier
  withMetadata:(NSDictionary *)metadata
withTarget:(id)target
   andSelector:(SEL)selector;

#pragma mark progress notifications
- (void)scheme:(EDExportImportScheme *)scheme startedWorkingWithMaxStepCount:(double)max;
- (void)scheme:(EDExportImportScheme *)scheme progressedInWorkBy:(double)progress;
- (void)scheme:(EDExportImportScheme *)scheme finishedWorkingWithValue:(double)finishingValue;

@required
- (void)scheme:(EDExportImportScheme *)scheme didFinishExecuteWithInfos:(NSDictionary *)infos;

@end
