//
//  EDExportImportSchemeProtocol.h
//  EDExportImportScheme
//
//  Created by Arnaud Thiercelin on 10/26/11.
//  Copyright (c) 2011 Flying Pig. All rights reserved.
//

#import <Foundation/Foundation.h>

@protocol EDExportImportSchemeProtocol <NSObject>

@required
// Needs to be implemented in subclass
- (void)load;

// Needs to be implemented in subclass
- (void)unload;

// data will be populated with a nsarray of nsdictionary where the key will be the 
// declared key assigned within the owner and the value, the information either from the
// DB or from the file.
// In the case of an Export, data is populated by the final data after any processing within the owner.
// Needs to be implemented in subclass
- (void)executeWithData:(NSArray *)data;


- (NSArray *)availableKeys;

@end
