//
//  EDExportScheme.h
//  EDExportImportScheme
//
//  Created by Arnaud Thiercelin on 10/26/11.
//  Copyright (c) 2011 Flying Pig. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <EDExportImportScheme/EDExportImportScheme.h>

@interface EDExportScheme : EDExportImportScheme
{
	IBOutlet NSView			*_configSheet;
	NSMutableArray			*_compiledData;
	NSArray						*_allowedFileTypes;
}
@property (readonly) NSView			*configSheet;	
@property (retain) NSMutableArray		*compiledData;
@property (readonly) NSArray				*allowedFileTypes;

#pragma mark API calls
// must call at least 
// - (void)scheme:(EDExportImportScheme *)scheme didFinishExecuteWithInfos:(NSDictionary *)infos;
// to notify of end of work to owner.
- (void)execute;

//provides default implementation to save as csv the compiledData.
- (void)exportToFile:(NSURL *)file;


#pragma mark ConfigView Display
// These are for the owner to notify the scheme it loaded the configSheet.
// This is useful when the config view need to pull data out of the database.
- (BOOL)configSheetShouldDisplay;
- (void)configSheetWillDisplay;
- (void)configSheetDidEndDisplay;

@end
