//
//  EDImportSchemeKey.h
//  EDExportImportScheme
//
//  Created by Arnaud Thiercelin on 11/7/11.
//  Copyright (c) 2011 Flying Pig. All rights reserved.
//

#import <Foundation/Foundation.h>

typedef enum
{
	EDImportSchemeKeyStringType = 0,
	EDImportSchemeKeyNumericType = 1,
	EDImportSchemeKeyDateType = 2
} EDImportSchemeKeyDataType;


@interface EDImportSchemeKey : NSObject
{
	NSString					*_key;
	
	id							_defaultValue;
	// Should be:
	// NSString or subclass if EDImportSchemeKeyStringType
	// NSNumber or subclass if EDImportSchemeKeyNumericType
	// NSDate or subclass if EDImportSchemeKeyDateType
	// will return nil if type does not match class at init.
	
	EDImportSchemeKeyDataType	_type;
}
@property (retain) NSString				*key;
@property (retain) id					defaultValue;
@property EDImportSchemeKeyDataType		type;

- (id)initWithKey:(NSString *)key withDefaultValue:(id)defaultValue andType:(EDImportSchemeKeyDataType)dataType;

+ (id)importKeyWithKey:(NSString *)key withDefaultValue:(id)defaultValue andType:(EDImportSchemeKeyDataType)dataType;

@end
