//
//  EDStatisticsReportOwnerProtocol.h
//  EDStatisticsReport
//
//  Created by Arnaud Thiercelin on 2/3/12.
//  Copyright (c) 2012 Flying Pig. All rights reserved.
//

#import <Foundation/Foundation.h>

@class EDStatisticsReport;

@protocol EDStatisticsReportOwnerProtocol <NSObject>

@required
@property (readonly) NSInteger currentUserLanguageId;
@property (readonly) BOOL runsCurrentFiscalYear;
@property (readonly) NSNumber *runningFiscalYearId;

#pragma mark SQL Bridge
- (BOOL)report:(EDStatisticsReport *)report 
wantsToExecRequest:(NSString *)request
withRequestIdentifier:(NSString *)requestIdentifier
  withMetadata:(NSDictionary *)metadata
andNotificationIdentifier:(NSString *)notifIdentifier;

@optional
- (BOOL)report:(EDStatisticsReport *)report
wantsToExecRequest:(NSString *)request
withRequestIdentifier:(NSString *)requestIdentifier
  withMetadata:(NSDictionary *)metadata
	withTarget:(id)target
   andSelector:(SEL)selector;

#pragma mark progress notifications
- (void)report:(EDStatisticsReport *)report startedWorkingWithMaxStepCount:(double)max;
- (void)report:(EDStatisticsReport *)report progressedInWorkBy:(double)progress;
- (void)report:(EDStatisticsReport *)report finishedWorkingWithValue:(double)finishingValue;

@required
- (void)report:(EDStatisticsReport *)report didFinishExecuteWithInfos:(NSDictionary *)infos;


@end
