//
//  FPModelLineView.h
//  FPCoreGraphic.framework
//
//  Created by Flying Pig on 24/10/06.
//  Copyright © 2006 Flying Pig. All rights reserved.
//

#import <Cocoa/Cocoa.h>

#import <FPTemplates/FPShapesTypes.h>
#import <FPTemplates/FPModelShapeView.h>



//Default Values
#define FPModelLineViewOriginPointXValue										-1
#define FPModelLineViewOriginPointYValue										-1
#define FPModelLineViewResizeValue												0
#define FPModelLineViewModeValue												0


/**
 * BLTR | TLTR
 * 21   | 11
 * _____|_____
 * TLBR | BLBR
 * 22   | 12
 *		|
**/


@interface FPModelLineView : FPModelShapeView <NSCoding, FPModelShapeViewProtocol>
{
@private
	NSPoint					_originPoint;
	FPLineMode				_mode;
	BOOL					_resize;
}

//Properties
@property NSPoint			originPoint;
@property FPLineMode		mode;
@property BOOL				resize;



@end
