//
//  FPModelScrollView.h
//  FPCoreGraphic.framework
//
//  Created by Flying Pig on 4/23/07.
//  Copyright © 2007 Flying Pig. All rights reserved.
//

#import <Cocoa/Cocoa.h>

#import <FPTemplates/FPShapesTypes.h>



//NSCoding Keys
#define FPModelScrollViewDisplayStrokeCodingKey								 	@"FPModelScrollViewDisplayStrokeCodingKey"
#define FPModelScrollViewStrokeColorCodingKey							 		@"FPModelScrollViewStrokeColorCodingKey"
#define FPModelScrollViewStrokeWidthCodingKey							 		@"FPModelScrollViewStrokeWidthCodingKey"
#define FPModelScrollViewFillColorCodingKey								 		@"FPModelScrollViewFillColorCodingKey"
#define FPModelScrollViewDisplayResizeRectCodingKey								@"FPModelScrollViewDisplayResizeRectCodingKey"
#define FPModelScrollViewDisplayFillCodingKey									@"FPModelScrollViewDisplayFillCodingKey"
#define FPModelScrollViewKeyCodingKey											@"FPModelScrollViewKeyCodingKey"
#define FPModelScrollViewTagCodingKey											@"FPModelScrollViewTagCodingKey"

//Drag Operation Types
#define FPTemplatesTableViewDragOperationType										@"FPTemplatesTableViewDragOperationType"	


//Default Values
#define FPModelScrollViewStrokeWidthValue										1.0
#define FPModelScrollViewErrorValue												-1

//Contextual Menu
#define FPModelTableViewContextMenuTitle										@"Menu"
#define FPModelTableViewContextMenuBringCloser									@"Bring Forward"
#define FPModelTableViewContextMenuSendBack										@"Send Backward"
#define FPModelTableViewContextMenuEdit											@"Edit"
#define FPModelTableViewContextMenuDelete										@"Delete"
#define FPModelTableViewContextMenuKeyEquivalent								@""	
#define FPModelTableViewContextMenuAddRow										@"Add Row"
#define FPModelTableViewContextMenuAddColumn									@"Add Column"



@class FPModelTableView;
@class FPModelTableTag;

@interface FPModelScrollView : NSScrollView <NSCoding, FPModelShapeViewProtocol, FPModelShapeViewTagProtocol> {

@private
	NSPoint									_clicPoint;
	NSPoint									_lastPoint;		
	BOOL									_displayResizeRect;
	BOOL									_currentEditedShape;
	BOOL									_displayStroke;
	BOOL									_displayFill;
	float									_strokeWidth;
	FPShapesActions							_shapeAction;
	NSColor									*_fillColor;
	NSColor									*_strokeColor;
	NSMenu									*_contextMenu;
	BOOL									_isBeingEdited;
	NSString								*_key;
	FPModelTableTag							*_modelTag;
}

//Propertes
@property NSPoint							clicPoint;
@property NSPoint							lastPoint;		
@property BOOL								displayResizeRect;
@property BOOL								currentEditedShape;
@property BOOL								displayStroke;
@property BOOL								displayFill;
@property float								strokeWidth;
@property FPShapesActions					shapeAction;
@property(retain) NSColor					*fillColor;
@property(retain) NSColor					*strokeColor;
@property(retain) NSMenu					*contextMenu;
@property BOOL								isBeingEdited;
@property(retain) NSString					*key;
@property(retain) FPModelTableTag			*modelTag;


//Getters
- (FPModelTableView *)documentView;


//Setters
- (void)setModelTagWithDefaultValues:(FPModelTableTag *)newModelTableTag;

@end
