//
//  FPModelShapeView.h
//  FPModel
//
//  Created by Flying Pig on 6/24/08.
//  Copyright © 2008 Flying Pig. All rights reserved.
//

#import <Cocoa/Cocoa.h>

#import <FPTemplates/FPShapesTypes.h>


//NSCoding Keys
#define FPModelShapeViewDisplayStrokeCodingKey								 	@"FPModelShapeViewDisplayStrokeCodingKey"
#define FPModelShapeViewStrokeColorCodingKey							 		@"FPModelShapeViewStrokeColorCodingKey"
#define FPModelShapeViewStrokeWidthCodingKey							 		@"FPModelShapeViewStrokeWidthCodingKey"
#define FPModelShapeViewFillColorCodingKey								 		@"FPModelShapeViewFillColorCodingKey"
#define FPModelShapeViewDisplayResizeRectCodingKey								@"FPModelShapeViewDisplayResizeRectCodingKey"
#define FPModelShapeViewDisplayFillCodingKey									@"FPModelShapeViewDisplayFillCodingKey"
#define FPModelShapeViewKeyCodingKey											@"FPModelShapeViewKeyCodingKey"
#define FPModelShapeViewTagCodingKey											@"FPModelShapeViewTagCodingKey"

//Default Values
#define FPModelShapeViewStrokeWidthValue										1.0


//Contextual Menu
#define FPModelShapeViewContextMenuTitle										@"Menu"
#define FPModelShapeViewContextMenuBringCloser									@"Bring Forward"
#define FPModelShapeViewContextMenuSendBack										@"Send Backward"
#define FPModelShapeViewContextMenuDelete										@"Delete"
#define FPModelShapeViewContextMenuKeyEquivalent								@""	




@interface FPModelShapeView : NSView <NSCoding, FPModelShapeViewProtocol, FPModelShapeViewTagProtocol> {

@private
	NSPoint									_clicPoint;
	NSPoint									_lastPoint;		
	BOOL									_displayResizeRect;
	BOOL									_currentEditedShape;
	BOOL									_displayStroke;
	float									_strokeWidth;
	NSColor									*_strokeColor;
	FPShapesActions							_shapeAction;
	BOOL									_displayFill;
	NSColor									*_fillColor;
	NSMenu									*_contextMenu;
	NSString								*_key;
	FPModelTag								*_modelTag;
}


//Properties
@property NSPoint							clicPoint;
@property NSPoint							lastPoint;
@property BOOL								displayResizeRect;
@property BOOL								currentEditedShape;
@property BOOL								displayStroke;
@property float								strokeWidth;
@property(retain) NSColor					*strokeColor;
@property FPShapesActions					shapeAction;
@property BOOL								displayFill;
@property(retain) NSColor					*fillColor;
@property(retain) NSMenu					*contextMenu;
@property(retain) NSString					*key;
@property(retain) FPModelTag				*modelTag;



@end
