//
//  FPModelTableHeaderView.h
//  FPModel
//
//  Created by Flying Pig on 9/3/08.
//  Copyright © 2008 Flying Pig. All rights reserved.
//

#import <Cocoa/Cocoa.h>


//Default values
#define FPModelTableHeaderViewNoIndexSelected									-1
#define FPModelTableHeaderViewDoubleClick										2


@class FPModelTextField;
@class FPModelScrollView;

@interface FPModelTableHeaderView : NSTableHeaderView {

@private
	FPModelTextField							*_tableHeaderTextField;
	NSInteger									_selectedTableHeaderCellIndex;
	NSMenu										*_contextMenu;
	FPModelScrollView							*_modelScrollView;
}


//Properties
@property(readonly, assign) FPModelTextField	*tableHeaderTextField;
@property(retain) NSMenu						*contextMenu;
@property(assign) FPModelScrollView				*modelScrollView;


//Init
- (id)initWithModelScrollView:(FPModelScrollView *)scrollView;

//Setters
- (void)setSelectedCellsTitleWithValue:(NSString *)value;


@end
