//
//  FPTextView.h
//  FPCoreGraphic.framework
//
//  Created by Flying Pig on 02/10/06.
//  Copyright © 2006 Flying Pig. All rights reserved.
//

#import <Cocoa/Cocoa.h>

#import <FPTemplates/FPShapesTypes.h>


//NSCoding Keys
#define FPModelTextViewDisplayResizeRectCodingKey								@"FPModelTextViewDisplayResizeRectCodingKey"
#define FPModelTextViewDisplayStrokeCodingKey									@"FPModelTextViewDisplayStrokeCodingKey"
#define FPModelTextViewDisplayFillCodingKey										@"FPModelTextViewDisplayFillCodingKey"
#define FPModelTextViewStrokeWidthCodingKey										@"FPModelTextViewStrokeWidthCodingKey"
#define FPModelTextViewShapeActionCodingKey										@"FPModelTextViewShapeActionCodingKey"
#define FPModelTextViewFillColorCodingKey										@"FPModelTextViewFillColorCodingKey"
#define FPModelTextViewStrokeColorCodingKey										@"FPModelTextViewStrokeColorCodingKey"
#define FPModelTextViewTagCodingKey												@"FPModelTextViewTagCodingKey"

//Drag Operation Types
#define FPTemplatesTextViewDragOperationType										@"FPTemplatesTextViewDragOperationType"	

//Default Values
#define FPModelTextViewStrokeWidthValue											1.0

//Events
#define FPModelTextViewDoubleClick												2

//Contextual Menu
#define FPModelTextViewContextMenuTitle											@"Menu"
#define FPModelTextViewContextMenuBringCloser									@"Bring Forward"
#define FPModelTextViewContextMenuSendBack										@"Send Backward"
#define FPModelTextViewContextMenuEdit											@"Edit"
#define FPModelTextViewContextMenuDelete										@"Delete"
#define FPModelTextViewContextMenuKeyEquivalent									@""	




@class FPModelTextTag;

@interface FPModelTextView : NSTextView <NSCoding, FPModelShapeViewProtocol, FPModelShapeViewTagProtocol>
{
	
@private	
	NSPoint								_clicPoint;
	NSPoint								_lastPoint;		
	BOOL								_displayResizeRect;
	BOOL								_currentEditedShape;
	BOOL								_displayStroke;
	float								_strokeWidth;
	NSColor								*_strokeColor;
	FPShapesActions						_shapeAction;
	NSColor								*_fillColor;
	BOOL								_displayFill;	
	NSMenu								*_contextMenu;
	BOOL								_isBeingEdited;	
	FPModelTextTag						*_modelTag;
}

//Properties
@property NSPoint						clicPoint;
@property NSPoint						lastPoint;
@property BOOL							displayResizeRect;
@property (setter = setCurrentEditedShape:) BOOL		currentEditedShape;
@property BOOL							displayStroke;
@property float							strokeWidth;
@property(retain) NSColor				*strokeColor;
@property FPShapesActions				shapeAction;
@property(retain) NSColor				*fillColor;
@property BOOL							displayFill;
@property(retain) NSMenu				*contextMenu;
@property (setter = setIsBeingEdited:) BOOL			isBeingEdited;
@property(retain) FPModelTextTag		*modelTag;


//Init
- (void)initIvars;

//Setups
- (void)setupViewDefaultSettings;
- (void)setupContextualMenu;
- (void)setupShapeViewWithProfilesValues;

//Enable / Disable Contextual Menu
- (void)enableEditContextualMenuItem;
- (void)disableEditContextualMenuItem;

//Setters
- (void)setIsBeingEdited:(BOOL)value;
- (void)setCurrentEditedShape:(BOOL)value;
- (void)setModelTagWithDefaultValues:(FPModelTextTag *)newModelTextTag;


@end
