//
//  FPModelsGraphActionsView.h
//  FPCoreGraphic.framework
//
//  Created by Flying Pig on 27/10/06.
//  Copyright © 2006 Flying Pig. All rights reserved.
//

#import <Cocoa/Cocoa.h>

#import <FPTemplates/FPShapesTypes.h>
#import <FPTemplates/FPModelLineView.h>


//NSCoding Keys
#define FPModelsGraphActionsViewKeyCodingKey									@"FPModelsGraphActionsViewKeyCodingKey"

//Drawing values
#define FPResizeRectSize														8
//#define FPModelsDash1															2.0
//#define FPModelsDash2															3.0
//Border
#define FPModelsGraphActionsViewBorderLineDashSize								4.0
#define FPModelsGraphActionsViewBorderLineDashCount								2
#define FPModelsGraphActionsViewBorderLineDashPhase								0.0	
//Selected Area
#define FPModelsGraphActionsViewLineWidth										1.0
#define FPModelsGraphActionsViewSelectedAreaRed									150.0
#define FPModelsGraphActionsViewSelectedAreaGreen								150.0
#define FPModelsGraphActionsViewSelectedAreaBlue								150.0
#define FPModelsGraphActionsViewSelectedAreaAlpha								0.15




@class FPTemplatesView;

@interface FPModelsGraphActionsView : NSView <NSCoding, FPModelShapeViewProtocol> {
	
@private
	FPTemplatesView					*_modelView;
	NSString						*_key;
	

	//Display page's frame
	//float							_frameDashStyle[2];
	//NSBezierPath					*_theFrame;
	//NSColor 						*_frameColor;

	//Selection Area
	NSRect							_selectArea;
	NSPoint							_mousePoint;
	NSPoint							_clicPoint;
	
	//Selected Shape(s)
	NSColor							*_selectedShapeColor;
	NSColor							*_selectedShapeBorderColor;
	NSColor							*_selectedAreaColor;
	NSColor							*_selectedAreaBorderColor;
	
}


//Properties
@property(retain) NSString 			*key;
@property NSPoint					mousePoint;
@property NSPoint					clicPoint;
@property NSRect					selectArea;

- (void)setupFrame;


//Drawing Implementation
- (void)drawResizeRectOfLine:(NSRect)rect withMode:(FPLineMode)mode;
- (void)drawResizeRectOfRect:(NSRect)rect;

//Actions
- (void)activate;

@end
