//
//  FPTemplateViewControllerProtocol.h
//  FPModel
//
//  Created by Arnaud Thiercelin on 12/18/12.
//
//

//
// This protocol is to be implemented by the controller who wishes to oversee the FPTemplateView 
// It describes feedbacks View > Controller.
//


#import <Foundation/Foundation.h>

@class FPTemplatesView;

@protocol FPTemplateViewControllerProtocol <NSObject>

#pragma mark Profiles Changes

- (void)templateView:(FPTemplatesView *)templateView didChangeProfileOnSubView:(NSView *)subview;

#pragma mark Drawing

- (void)templateView:(FPTemplatesView *)templateView isDrawingSubView:(NSView *)subview;
- (void)templateView:(FPTemplatesView *)templateView didFinishDrawingSubView:(NSView *)subview;

#pragma mark Moving/Displacing

- (void)templateView:(FPTemplatesView *)templateView isMovingSubView:(NSView *)subview;
- (void)templateView:(FPTemplatesView *)templateView didFinishMovingSubView:(NSView *)subview;

#pragma mark Resizing

- (void)templateView:(FPTemplatesView *)templateView isResizingSubView:(NSView *)subview;
- (void)templateView:(FPTemplatesView *)templateView didFinishResizingSubView:(NSView *)subview;


#pragma mark Graphics


#pragma mark Metrics



#pragma mark Text

- (void)templateView:(FPTemplatesView *)templateView didAdjustAlignmentTo:(NSTextAlignment)textAlignment;

#pragma mark Layers

// This method is a failsafe method. Should only be called if none of the above can.
- (void)controllerShouldRefreshLayersVisual;

- (void)templateView:(FPTemplatesView *)templateView didMoveFrontSubView:(NSView *)subview;
- (void)templateView:(FPTemplatesView *)templateView didMoveBackSubView:(NSView *)subview;
- (void)templateView:(FPTemplatesView *)templateView didDeleteSubView:(NSView *)subview;
- (void)templateView:(FPTemplatesView *)templateView didAddSubView:(NSView *)subview;

- (void)templateView:(FPTemplatesView *)templateView didSelectSubView:(NSView *)subview; // nil means deselection.

@end
