//
//  FPTemplatesSerialTag.h
//  FPModel
//
//  Created by Arnaud Thiercelin on 6/21/11.
//  Copyright 2011 Flying Pig. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <FPTemplates/FPModelTextTag.h>
#import <FPTemplates/FPTemplatesSerialTagProtocol.h>

#define FPTemplatesSerialTagSerialIdentifierCodingKey		@"FPTemplatesSerialTagSerialIdentifierCodingKey"
#define FPTemplatesSerialTagDataSourceCodingKey			@"FPTemplatesSerialTagDataSourceCodingKey"

// Documentation:
// Serial tag allows items to be considered as working together.
// they work on text tag-capable items only.
// The datasource works as an array of dictionary which must contains a value
// with a key = identifier 

@interface FPTemplatesSerialTag : FPModelTextTag <FPTemplatesSerialTagProtocol>
{
    NSString						*_serialIdentifier;
	NSMutableArray			*_dataSource;
}

@property (retain) NSString				*serialIdentifier;
@property (retain) NSMutableArray	*dataSource;


@end
